#include "common.h"

void put_timeval( struct timeval *tv, char *res ) {
   sprintf( res, "%02lu:%06lu", ( tv->tv_sec % 60 ), tv->tv_usec );
}

void slice( unsigned int activ_persent ) {
   if( activ_persent > 100 ) return;
   if( activ_persent != 100 ) {  // пассивная часть
      struct timespec msec;
      msec.tv_sec = 0;
      msec.tv_nsec = (long)( 100 - activ_persent ) * 1000000L;
      nanosleep( &msec, NULL );
   }
   if( activ_persent != 0 ) {   // активная часть
      struct timeval msec;
      gettimeofday( &msec, NULL );
      msec.tv_usec += (long)activ_persent * 1000L;
      if( msec.tv_usec > 1000000L ) {
         msec.tv_sec += 1; msec.tv_usec -= 1000000L;
      }
      while( 1 ) {
         struct timeval curr;
         gettimeofday( &curr, NULL );
         if( curr.tv_sec > msec.tv_sec ) break;
         if( curr.tv_sec == msec.tv_sec && curr.tv_usec >= msec.tv_usec ) break;
      }
   }
   return;
}

